//#line 2 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the pointcloud_to_laserscan package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __pointcloud_to_laserscan__CLOUDSCANCONFIG_H__
#define __pointcloud_to_laserscan__CLOUDSCANCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace pointcloud_to_laserscan
{
  class CloudScanConfigStatics;
  
  class CloudScanConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(CloudScanConfig &config, const CloudScanConfig &max, const CloudScanConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const CloudScanConfig &config1, const CloudScanConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, CloudScanConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const CloudScanConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, CloudScanConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const CloudScanConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T CloudScanConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (CloudScanConfig::* field);

      virtual void clamp(CloudScanConfig &config, const CloudScanConfig &max, const CloudScanConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const CloudScanConfig &config1, const CloudScanConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, CloudScanConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const CloudScanConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, CloudScanConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const CloudScanConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 42 "../cfg/CloudScan.cfg"
      double min_height;
//#line 43 "../cfg/CloudScan.cfg"
      double max_height;
//#line 45 "../cfg/CloudScan.cfg"
      double angle_min;
//#line 46 "../cfg/CloudScan.cfg"
      double angle_max;
//#line 47 "../cfg/CloudScan.cfg"
      double angle_increment;
//#line 48 "../cfg/CloudScan.cfg"
      double scan_time;
//#line 49 "../cfg/CloudScan.cfg"
      double range_min;
//#line 50 "../cfg/CloudScan.cfg"
      double range_max;
//#line 52 "../cfg/CloudScan.cfg"
      std::string output_frame_id;
//#line 138 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("CloudScanConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const CloudScanConfig &__max__ = __getMax__();
      const CloudScanConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const CloudScanConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const CloudScanConfig &__getDefault__();
    static const CloudScanConfig &__getMax__();
    static const CloudScanConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const CloudScanConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void CloudScanConfig::ParamDescription<std::string>::clamp(CloudScanConfig &config, const CloudScanConfig &max, const CloudScanConfig &min) const
  {
    return;
  }

  class CloudScanConfigStatics
  {
    friend class CloudScanConfig;
    
    CloudScanConfigStatics()
    {
//#line 42 "../cfg/CloudScan.cfg"
      __min__.min_height = -10.0;
//#line 42 "../cfg/CloudScan.cfg"
      __max__.min_height = 10.0;
//#line 42 "../cfg/CloudScan.cfg"
      __default__.min_height = 0.1;
//#line 42 "../cfg/CloudScan.cfg"
      __param_descriptions__.push_back(CloudScanConfig::AbstractParamDescriptionConstPtr(new CloudScanConfig::ParamDescription<double>("min_height", "double", 0, "The minimum height to include from the point cloud.", "", &CloudScanConfig::min_height)));
//#line 43 "../cfg/CloudScan.cfg"
      __min__.max_height = -10.0;
//#line 43 "../cfg/CloudScan.cfg"
      __max__.max_height = 10.0;
//#line 43 "../cfg/CloudScan.cfg"
      __default__.max_height = 0.15;
//#line 43 "../cfg/CloudScan.cfg"
      __param_descriptions__.push_back(CloudScanConfig::AbstractParamDescriptionConstPtr(new CloudScanConfig::ParamDescription<double>("max_height", "double", 0, "The maximum height to include from the point cloud.", "", &CloudScanConfig::max_height)));
//#line 45 "../cfg/CloudScan.cfg"
      __min__.angle_min = -3.14159265359;
//#line 45 "../cfg/CloudScan.cfg"
      __max__.angle_min = 3.14159265359;
//#line 45 "../cfg/CloudScan.cfg"
      __default__.angle_min = -1.57079632679;
//#line 45 "../cfg/CloudScan.cfg"
      __param_descriptions__.push_back(CloudScanConfig::AbstractParamDescriptionConstPtr(new CloudScanConfig::ParamDescription<double>("angle_min", "double", 0, "The minimum angle of the resulting laser scan.", "", &CloudScanConfig::angle_min)));
//#line 46 "../cfg/CloudScan.cfg"
      __min__.angle_max = -3.14159265359;
//#line 46 "../cfg/CloudScan.cfg"
      __max__.angle_max = 3.14159265359;
//#line 46 "../cfg/CloudScan.cfg"
      __default__.angle_max = 1.57079632679;
//#line 46 "../cfg/CloudScan.cfg"
      __param_descriptions__.push_back(CloudScanConfig::AbstractParamDescriptionConstPtr(new CloudScanConfig::ParamDescription<double>("angle_max", "double", 0, "The maximum angle of the resulting laser scan.", "", &CloudScanConfig::angle_max)));
//#line 47 "../cfg/CloudScan.cfg"
      __min__.angle_increment = 0.0;
//#line 47 "../cfg/CloudScan.cfg"
      __max__.angle_increment = 3.14159265359;
//#line 47 "../cfg/CloudScan.cfg"
      __default__.angle_increment = 0.00872664625997;
//#line 47 "../cfg/CloudScan.cfg"
      __param_descriptions__.push_back(CloudScanConfig::AbstractParamDescriptionConstPtr(new CloudScanConfig::ParamDescription<double>("angle_increment", "double", 0, "The angle increment of the resulting laser scan.", "", &CloudScanConfig::angle_increment)));
//#line 48 "../cfg/CloudScan.cfg"
      __min__.scan_time = 0.0;
//#line 48 "../cfg/CloudScan.cfg"
      __max__.scan_time = 1.0;
//#line 48 "../cfg/CloudScan.cfg"
      __default__.scan_time = 0.0333333333333;
//#line 48 "../cfg/CloudScan.cfg"
      __param_descriptions__.push_back(CloudScanConfig::AbstractParamDescriptionConstPtr(new CloudScanConfig::ParamDescription<double>("scan_time", "double", 0, "The scan time of the resulting laser scan.", "", &CloudScanConfig::scan_time)));
//#line 49 "../cfg/CloudScan.cfg"
      __min__.range_min = 0.0;
//#line 49 "../cfg/CloudScan.cfg"
      __max__.range_min = 100.0;
//#line 49 "../cfg/CloudScan.cfg"
      __default__.range_min = 0.45;
//#line 49 "../cfg/CloudScan.cfg"
      __param_descriptions__.push_back(CloudScanConfig::AbstractParamDescriptionConstPtr(new CloudScanConfig::ParamDescription<double>("range_min", "double", 0, "The minimum range of the resulting laser scan.", "", &CloudScanConfig::range_min)));
//#line 50 "../cfg/CloudScan.cfg"
      __min__.range_max = 0.0;
//#line 50 "../cfg/CloudScan.cfg"
      __max__.range_max = 100.0;
//#line 50 "../cfg/CloudScan.cfg"
      __default__.range_max = 10.0;
//#line 50 "../cfg/CloudScan.cfg"
      __param_descriptions__.push_back(CloudScanConfig::AbstractParamDescriptionConstPtr(new CloudScanConfig::ParamDescription<double>("range_max", "double", 0, "The maximum range of the resulting laser scan.", "", &CloudScanConfig::range_max)));
//#line 52 "../cfg/CloudScan.cfg"
      __min__.output_frame_id = "";
//#line 52 "../cfg/CloudScan.cfg"
      __max__.output_frame_id = "";
//#line 52 "../cfg/CloudScan.cfg"
      __default__.output_frame_id = "/openi_depth_frame";
//#line 52 "../cfg/CloudScan.cfg"
      __param_descriptions__.push_back(CloudScanConfig::AbstractParamDescriptionConstPtr(new CloudScanConfig::ParamDescription<std::string>("output_frame_id", "str", 0, "The frame id of the resulting laser scan.", "", &CloudScanConfig::output_frame_id)));
//#line 239 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<CloudScanConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<CloudScanConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    CloudScanConfig __max__;
    CloudScanConfig __min__;
    CloudScanConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const CloudScanConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static CloudScanConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &CloudScanConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const CloudScanConfig &CloudScanConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const CloudScanConfig &CloudScanConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const CloudScanConfig &CloudScanConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<CloudScanConfig::AbstractParamDescriptionConstPtr> &CloudScanConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const CloudScanConfigStatics *CloudScanConfig::__get_statics__()
  {
    const static CloudScanConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = CloudScanConfigStatics::get_instance();
    
    return statics;
  }


}

#endif // __CLOUDSCANRECONFIGURATOR_H__
